/* Problem URL: https://codeforces.com/contest/2121/problem/C */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;

        vvi fds(n, vi(m));
        cin >> fds;

        V<V<pair<int, int>>> count(101);

        rep(i, n) {
            rep(j, m) {
                count[fds[i][j]].emplace_back(i, j);
            }
        }

        int i = 100;
        while (count[i].empty()) {
            i--;
        }

        bool pos = true;
        map<int, int> countsi;
        int maximal = 0;
        int choice = 0;

        bool byj = false;
        
        rep(j, count[i].size()) {
            countsi[count[i][j].first]++;
            if (countsi[count[i][j].first] > maximal) {
                maximal = countsi[count[i][j].first];
                choice = count[i][j].first;
            }
        }

        map<int, int> countsj;

        rep(j, count[i].size()) {
            countsj[count[i][j].second]++;
            if (countsj[count[i][j].second] > maximal) {
                maximal = countsj[count[i][j].second];
                choice = count[i][j].second;
                byj = true;
            }
        }


        set<int> c;
        for (int j = 0; j < count[i].size(); j++) {
            if ((!byj && count[i][j].first == choice) || (byj && count[i][j].second == choice)) {
                continue;
            }
            c.insert(byj ? count[i][j].first : count[i][j].second);
        }

        if (c.size() < 2) {
            cout << i - 1 << '\n';
        } else {
            cout << i << '\n';
        }
    }
}
